/*
 * lab1.c
 */

#include "lcd.h"

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>   

#define MORSE_LUNG  3
#define MORSE_SCURT 1
#define MORSE_MEDIU 2

 
 int level = 1;
 int ok = 1;
 uint8_t *order;
 int size;
 int bonus = 0;
 int smileys = 1;
 
void speaker_morse(int tip)
{
    int delay = 5;
    int i;
    DDRD |= (1 << PD4);     

    for (i = 0; i < tip * 100 / delay; i++)
    {
        PORTD ^= (1 << PD4); 
        _delay_ms(1);
    }
}


void clear_lcd()
{
	LCD_writeInstr(1);
}

//functie in care este afisat pe LCD modelul ce trebuie urmat
void task1_lcd()
{

     // initializari
	int offset=0;
	char msg[] = "mesaj";
	LCD_printAt(offset, msg);
	
	int x=0;
	//uint8_t v[] = {1,0,0,0,1};
	// main loop
	while(1)
	{
		clear_lcd();
		
		if (order[x] == 0)
		{
			char msg[] = "LEFT";
			speaker_morse(1);
		//	LCD_printAt(2, msg);
			LCD_printAt(0x40, msg);
			LCD_writeInstr(LCD_INSTR_DDRAM);
			_delay_ms(500);
			clear_lcd();
			_delay_ms(100);
		}
		else
		{
			char msg[] = "RIGHT";
			speaker_morse(10);
			LCD_printAt(0x47, msg);
			LCD_writeInstr(LCD_INSTR_DDRAM);
			_delay_ms(500);
			clear_lcd();
		}
		x++;
		if (x == size)
		{
			x = 0;
			break;
		}
			
	}
	
}

//functie ce verifica corectitudinea input-ului utilizatorului
void task2_lcd()
{
	uint8_t chuck[] = {0x00, 0x0e, 0x0e, 0x04, 0x1F, 0x04, 0x0e, 0xa};
	int y,l;
	uint8_t start;

	DDRD &= ~(1 << PD0);
	PORTD |= (1 << PD0);
	DDRD &= ~(1 << PD1);
	PORTD |= (1 << PD1);
	
	LCD_writeInstr(LCD_INSTR_CGRAM);
    for(uint8_t i = 0; i < sizeof(chuck); ++i)
        LCD_writeData(chuck[i]);
    LCD_writeInstr(LCD_INSTR_DDRAM);
	
	y = 0;
	while(1)
	{
		if (y == size)
		{
			char msg[] = "Good Job";
			LCD_printAt(0x00, msg);
			l = 0;
			start = 0x40;
			while (1)
			{
				LCD_putCharAt(start, 0);
				start++;
				l++;
				if (l == smileys)
					break;
			}
			_delay_ms(800);
			clear_lcd();
			break;
		}
		if ((PIND & (1 << PD0)) == 0) 
		{
			speaker_morse(1);
			clear_lcd();
			if (order[y] == 0)
			{
				y++;
				char msg[] = "LEFT";
				LCD_printAt(0x40, msg);
				_delay_ms(400);
				clear_lcd();
				continue;
			}
			else
			{
				char msg[] = "YOU LOSE";
				speaker_morse(1);
				LCD_printAt(0x00, msg);
				_delay_ms(1000);
				clear_lcd();
				ok = 0;
				break;
			}
		}
		if ((PIND & (1 << PD1)) == 0) 
		{
			speaker_morse(10);
			if (order[y] == 1)
			{
				y++;
				char msg[] = "RIGHT";
				LCD_printAt(0x47, msg);
				_delay_ms(400);
				clear_lcd();
				continue;
			}
			else
			{
				char msg[] = "YOU LOSE!";
				LCD_printAt(0x00, msg);
				_delay_ms(1000);
				clear_lcd();
				ok = 0;
				break;
			}
		}	
	}
}

//runda bonus 
void bonus_round()
{
	uint8_t chuck[] = {0x00, 0x0e, 0x0e, 0x04, 0x0e, 0x04, 0x0e, 0xa};
	int8_t pos_old = 0x48;
	int8_t pos_new = 0x48;
	int8_t pos;
	int count,c;
	
    
	DDRD &= ~(1 << PD0);
	PORTD |= (1 << PD0);
	DDRD &= ~(1 << PD1);
	PORTD |= (1 << PD1);

    LCD_writeInstr(LCD_INSTR_CGRAM);
    for(uint8_t i = 0; i < sizeof(chuck); ++i)
        LCD_writeData(chuck[i]);
    LCD_writeInstr(LCD_INSTR_DDRAM);

    LCD_putCharAt(pos_old, 0);
	
	//initializare model de urmat
	srand(1);
	order = malloc(7 * sizeof(uint8_t));
	for (c = 0;c < 7;c++)
		order[c] = rand()%2;
	
	count = 0;
	while (1)
	{
		if (count == 6)
			break;
			
		if (order[count] == 0)
			pos_new -= 1;
		else
			pos_new +=1;
			
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_putCharAt(pos_new, 0);
		_delay_ms(600);
		count ++;
		
	}
	
	LCD_printAt(0x00, "Now repeat");
	_delay_ms(500);
	clear_lcd();
	
	LCD_putCharAt(pos_old, 0);
	pos = pos_old;
	count = 0;
    while(1)
    {
		//daca input-ul utilizatorului a fost corect - castiga runda bonus
		if (count == 6)
		{
			bonus = 1;
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_printAt(0x00, "WONDERFUL!");
			_delay_ms(700);
			break;
		}
		
		if ((PIND & (1 << PD0)) == 0) 
        {
            pos -= 1;
			//daca input-ul e corect se continua
            if (order[count] == 0)
			{
				count ++;
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_putCharAt(pos, 0);
				_delay_ms(600);
				continue;
			}
			//daca input-ul e gresit runda bonus se termina
			else
			{
				char msg[] = "BONUS LOST";
				LCD_printAt(0x00, msg);
				_delay_ms(1000);
				break;
			}	
        }
        if ((PIND & (1 << PD1)) == 0) 
        {
            pos += 1;
			//daca input-ul e corect se continua
            if (order[count] == 1)
			{
				count ++;
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_putCharAt(pos, 0);
				_delay_ms(600);
				continue;
			}
			//daca input-ul e gresit runda bonus se termina
			else
			{
				char msg[] = "BONUS LOST";
				LCD_printAt(0x00, msg);
				_delay_ms(1000);
				break;
			}	
		}
	}
}

int main()
{

	uint8_t levels[] = {3,3,4,5,6,7,8,9,10,11};
	uint8_t load[] = {0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F, 0x1F};
	uint8_t t;
	int c;

	LCD_init();

    LCD_writeInstr(LCD_INSTR_CGRAM);
    for(uint8_t i = 0; i < sizeof(load); ++i)
        LCD_writeData(load[i]);
    LCD_writeInstr(LCD_INSTR_DDRAM);
	
	
	LCD_printAt(0x00, "MEMORY GAME");
	t = 0x40;
	while (1)
	{
		if (t == 0x4F)
			break;
		LCD_putCharAt(t, 0);
		_delay_ms(150);
		t++;
	}

	clear_lcd();
	srand(1);

	while (1)
	{
		LCD_printAt(0x00, "NEW LEVEL");
		_delay_ms(1000);
		clear_lcd();
		
		//runda bonus
		if (level % 3 == 0)
		{
			bonus_round();
			//runda bonus a fost castigata
			if (bonus == 1)
			{
				smileys++;
				bonus = 0;
			}
			LCD_printAt(0x00, "New Level");
			_delay_ms(800);
			clear_lcd();
		}
			
		//preiau lungimea modelului nivelului curent
		size = levels[level-1];
		
		if (order != 0) {
			order = malloc(size * sizeof(uint8_t));
		}
		else
			order = realloc(order,size * sizeof(uint8_t));
		
		//initializez modelul de urmat
		for (c = 0;c < levels[level - 1];c++)
			order[c] = rand() % 2;

		//afisez modelul de urmat
		task1_lcd();
 
		LCD_printAt(0x00, "NOW REPEAT!");
		_delay_ms(1000);
		clear_lcd();

		//verific input-ul utilizatorului
		task2_lcd();
		
		//input-ul utilizatorului a fost corect -> urmatorul nivel
		if (ok == 1)
		{
			level++;
			smileys ++;
		}
		//input-ul utilizatorului a fost gresit
		else
		{
			LCD_printAt(0x00, "GAME OVER!");
			_delay_ms(1000);
			clear_lcd();
			break;
		}
	
		//daca a fost atins numarul maxim de nivele
		if (level == sizeof(levels) + 1)
		{
			LCD_printAt(0x00, "YOU WON!");
			_delay_ms(1000);
			clear_lcd();
			break;
		}
	}
    
	return 0;
}

